import 'package:flutter/material.dart';
import 'package:navigine_api/navigine_api.dart';
import '../widgets/sub_location_image.dart';

class LocationDetail extends StatefulWidget {
  final Location location;
  LocationDetail({this.location});

  @override
  _LocationDetailState createState() => _LocationDetailState();
}

class _LocationDetailState extends State<LocationDetail> {
  Location l;
  SubLocation selected;

  initState() {
    super.initState();
    l = widget.location;
    print(l.subLocations);
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(l.title),
      ),
      body: Column(
        children: <Widget>[
          Expanded(
            child: ListView.builder(
              itemBuilder: (context, index) {
                SubLocation sl = l.subLocations[index];
                return ListTile(
                  title: Text(sl.title),
                  onTap: () async {
                    await sl.getImageURL();

                    setState(() {
                      selected = sl;
                    });
                  },
                );
              },
              itemCount: l.subLocations.length,
            ),
          ),
          selected == null
              ? SizedBox()
              : SubLocationWidget(
                  selected,
                  onTap: (Offset pos) async {
                    var resp = await selected.addBeacon(
                        uuid: "534e4f57-6d11-1111-1111-111111111130",
                        pw: -1,
                        major: 12312,
                        minor: 323,
                        description: "Beacon",
                        kx: pos.dx,
                        ky: pos.dy,
                        powerNav: 0);
                    print(resp);
                  },
                ),
        ],
      ),
    );
  }
}
